﻿using System;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using System.IO;
using System.Collections.Generic;
using System.Linq;

namespace DateFormatinFE
{
     public partial class FileExplorerController: Controller
    {
        public ActionResult FileExplorerFeatures()
        {
              return View();
        }
	public ActionResult FileActionDefault(FileExplorerParams args)
        {
	    FileExplorerOperations operation = new FileExplorerOperations();
            switch (args.ActionType)
            {
                case "Read":
                    return Json(ConvertDateFormat(operation.Read(args.Path, args.ExtensionsAllow)));
                case "CreateFolder":
                    return Json(ConvertDateFormat(operation.CreateFolder(args.Path, args.Name)));
                case "Paste":
                    return Json(ConvertDateFormat(operation.Paste(args.LocationFrom, args.LocationTo, args.Names, args.Action, args.CommonFiles)));
                case "Remove":
                    return Json(ConvertDateFormat(operation.Remove(args.Names, args.Path)));
                case "Rename":
                    return Json(ConvertDateFormat(operation.Rename(args.Path, args.Name, args.NewName, args.CommonFiles)));
                case "GetDetails":
                    return Json(ConvertDateFormat(operation.GetDetails(args.Path, args.Names), true));
                case "Download":
                    operation.Download(args.Path, args.Names);
                    break;               
                case "Upload":
                    operation.Upload(args.FileUpload, args.Path);
                    break;
                case "Search":
                    return Json(ConvertDateFormat(operation.Search(args.Path, args.ExtensionsAllow, args.SearchString, args.CaseSensitive)));
            }
            return Json("");
        }
        public virtual FileExplorerResponse ConvertDateFormat(object response, bool getDetails= false)
        {
            FileExplorerResponse ReadResponse = (FileExplorerResponse) response;

            if (getDetails)
            {
                var listResponse = ReadResponse.details.ToList();
                for (int i = 0; i < listResponse.Count; i++)
                {
                    DateTime created = Convert.ToDateTime(listResponse[i].Created);
                    listResponse[i].Created = created.ToString("dd/MM/yyyy");
                    DateTime modified = Convert.ToDateTime(listResponse[i].Modified);
                    listResponse[i].Modified = modified.ToString("dd/MM/yyyy");
                }
                ReadResponse.details = listResponse;
            }
            else
            {
                var listResponse = ReadResponse.files.ToList();
                for (int i = 0; i < listResponse.Count; i++)
                {
                    DateTime dt = Convert.ToDateTime(listResponse[i].dateModified);
                    listResponse[i].dateModified = dt.ToString("dd/MM/yyyy");
                }
                ReadResponse.files = listResponse;
            }
           
            return ReadResponse;
        } 
    }
}
